﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace 获取文件路径及扩展名等
{
    public partial class 使用Path : Form
    {
        public 使用Path()
        {
            InitializeComponent();
        }
        private void btnOpenDialog_Click(object sender, EventArgs e)
        {
            OpenFileDialog op = new OpenFileDialog();            
            if (op.ShowDialog()==DialogResult.OK)
            {
                lblFullPath.Text = op.FileName; 
            }
        }
        private void 使用Path_Load(object sender, EventArgs e)
        {
            //载入时添加内容
            cboPath.Items.Add(@"c:\myfiles\mp3\");
            cboPath.Items.Add(@"c:\myfiles\mp3");
            txtFileName.Text = "nobody.mp3";
        }

        private void btnFileNameWithoutExtension_Click(object sender, EventArgs e)
        {
            //GetFileNameWithoutExtension：返回不具有扩展名的指定路径字符串的文件名
            lblFileNameWithoutExtension.Text = Path.GetFileNameWithoutExtension(lblFullPath.Text);
        }

        private void btnGetDirectoryName_Click(object sender, EventArgs e)
        {
            //GetDirectoryName:获取指定路径字符串的目录信息
            lblDirectoryName.Text = Path.GetDirectoryName(lblFullPath.Text);
        }

        private void btnGetExtension_Click(object sender, EventArgs e)
        {
            //GetExtension:获取指定路径字符串的扩展名
            lblExtension.Text = Path.GetExtension(lblFullPath.Text);
        }

        private void btnGetPathRoot_Click(object sender, EventArgs e)
        {
            //GetPathRoot:获取指定路径字符串的根目录
            lblPathRoot.Text = Path.GetPathRoot(lblFullPath.Text);
        }

        private void btnGetFileName_Click(object sender, EventArgs e)
        {
            //GetFileName:获取指定字符串的文件名和扩展名
            lblFileName.Text = Path.GetFileName(lblFullPath.Text);
        }

        private void btnGetFullFileName_Click(object sender, EventArgs e)
        {
            string path = cboPath.Text;
            string fileName = txtFileName.Text;
            //不使用Combine的解法
            //if (path.EndsWith(@"\"))
            //{
            //    label9.Text = path + fileName;
            //}
            //else
            //{
            //    label9.Text = path + "\\" + fileName;
            //}
            //Combine:合并两个路径字符串
            label9.Text = Path.Combine(path, fileName);
        }

        private void btnParentPath_Click(object sender, EventArgs e)
        {
            DirectoryInfo di = new DirectoryInfo(cboPath.Text);
            if (di.Parent != null)
            {
                label9.Text = di.Parent.FullName;
            }
            else
            {
                label9.Text = "已经是根目录了";
            }
            //不使用Parent的解法
            //string path = cboPath.Text;
            //if (path.EndsWith(@"\"))
            //{
            //    path = path.Substring(0, path.Length - 1);
            //    label9.Text = path.Substring(0, path.LastIndexOf(@"\") + 1);
            //}
            //else
            //{
            //    label9.Text = path.Substring(0, path.LastIndexOf(@"\") + 1);
            //}

        }

        private void button1_Click(object sender, EventArgs e)
        {
            string str = @"C:\Documents and Settings\ty\桌面\工程测试\tttttttt\kkk\vv.txt";
            //通过"\\"分割字符串后，取长度-6，即从后往前数的第六项，应文件名占用了一项，第六项实际是第五层目录
            label11.Text = str.Split('\\')[str.Split('\\').Length - 6];

        }




    }
}
